<?php
rg_log("FILE: /inc/user/repo/bug/show/show");

// TODO: security checks

$_bug_show = '';

$rg['HTML:bug_edit'] = '';
$rg['HTML:button_error'] = '';

$ibug = rg_bug_info($db, $rg['ri']['repo_id'], $rg['bug']['bug_id']);
if ($ibug === FALSE)
	rg_fatal("Cannot lookup bug!");

$rg['bug'] = array_merge($rg['bug'], $ibug);

if ($ibug['exists'] != 1) {
	$_bug_body .= rg_template("repo/bug/not_found.html", $rg, TRUE /*xss*/);
	return;
}

$x = array();
$x['obj_id'] = $rg['ri']['repo_id'];
$x['type'] = 'repo';
$x['owner'] = $rg['ri']['uid'];
$x['uid'] = $rg['login_ui']['uid'];
$x['username'] = $rg['login_ui']['username'];
$x['ip'] = $rg['ip'];
$x['misc'] = '';

// If bug is deleted and the user does not have 'delete' rights, deny access.
if ($ibug['deleted'] > 0) {
	$x['needed_rights'] = 'd';
	if (rg_rights_allow($db, $x) !== TRUE) {
		$_bug_body .= rg_template("repo/bug/deleted.html", $rg, TRUE /*xss*/);
		return;
	}
}

// load labels
$labels = rg_bug_label_get($db, $rg['ri']['repo_id'], $rg['bug']['bug_id']);
if ($labels === FALSE)
	$rg['HTML:labels_html'] = rg_warning('Cannot load labels!', $rg);
else
	$rg['HTML:labels_html'] = rg_bug_label_html($db, $labels);
$rg['bug']['labels'] = implode(" ", $labels);

// edit
$rg['rg_form_token_tag'] = 'bug_edit_hl';
$rg['rg_form_token'] = rg_token_get($db, $rg, 'bug_edit_hl');
$rg['HTML:edit_form'] = rg_template("repo/bug/b_edit.html", $rg, TRUE /*xss*/);
if (rg_var_uint("edit") == 1)
	$rg['HTML:bug_edit'] = rg_bug_edit_high_level($db, $rg);

// close/re-open
$close_reopen_error = '';
while (1) {
	if (rg_var_uint("close_reopen") != 1)
		break;

	$ibug['state'] = rg_var_uint("state");
	$ibug['state_text'] = rg_bug_state($ibug['state']);

	if ($ibug['state'] == 1) { // reopen
		$x['needed_rights'] = 'r';
		if (rg_rights_allow($db, $x) !== TRUE) {
			rg_template("repo/bug/deny_reopen.html", $rg, TRUE /*xss*/);
			break;
		}
	} else { // close
		$x['needed_rights'] = 'C';
		if (rg_rights_allow($db, $x) !== TRUE) {
			rg_template("repo/bug/deny_close.html", $rg, TRUE /*xss*/);
			break;
		}
	}

	if (!rg_valid_referer()) {
		$close_reopen_error = rg_warning('Invalid referer; try again', $rg);
		break;
	}

	if (!rg_token_valid($db, $rg, 'close_reopen', FALSE)) {
		$close_reopen_error = rg_warning('Invalid token. Try again.', $rg);
		break;
	}

	$ret = rg_bug_edit($db, $rg['login_ui'], $rg['ri'], $ibug);
	if ($ret === FALSE) {
		$close_reopen_error = rg_warning('Cannot edit bug (' . rg_bug_error() . ')', $rg);
		break;
	}

	// TODO: do something with the error code
	break;
}
if ($ibug['state'] == 1)
	$t = "repo/bug/b_close.html";
else
	$t = "repo/bug/b_reopen.html";
$rg['rg_form_token_tag'] = 'close_reopen';
$rg['rg_form_token'] = rg_token_get($db, $rg, 'close_reopen');
$rg['HTML:close_form'] = rg_template($t, $rg, TRUE /*xss*/);
if (!empty($close_reopen_error))
	$rg['HTML:button_error'] = $close_reopen_error;


// 'add_note' must be unconditionally included because we must insert the form
include($INC . "/user/repo/bug/show/add_note.php");

// load notes
$notes = rg_bug_note_list($db, $rg['ri']['repo_id'],
	$rg['bug']['bug_id'], 0);
if ($notes === FALSE)
	$rg['HTML:notes'] = rg_warning('Cannot load notes!', $rg);
else
	$rg['HTML:notes'] = rg_template_table("repo/bug/list_note", $notes, $rg);


// watch
$watch_error = '';
$watch = rg_watch_load($db, "bug", $rg['login_ui']['uid'], $rg['ri']['repo_id'],
	$rg['bug']['bug_id']);
if ($watch === FALSE) {
	$watch_error = rg_warning("Internal error.");
} else {
	while (1) {
		if (rg_var_uint('watch_doit') != 1)
			break;

		if (rg_var_uint('watch') == $watch) {
			rg_log('Already in propoer state');
			break;
		}

		if (!rg_valid_referer()) {
			$watch_error = rg_warning('Invalid referer; try again', $rg);
			break;
		}

		if (!rg_token_valid($db, $rg, 'bug_watch', FALSE)) {
			$watch_error = rg_warning('Invalid token. Try again.', $rg);
			break;
		}

		if (rg_var_uint('watch') == 1)
			$r = rg_watch_add($db, 'bug', $rg['login_ui']['uid'],
				$rg['ri']['repo_id'], $rg['bug']['bug_id']);
		else
			$r = rg_watch_del($db, 'bug', $rg['login_ui']['uid'],
				$rg['ri']['repo_id'], $rg['bug']['bug_id']);
		if ($r === FALSE) {
			$watch_error = rg_warning('Internal error. Try again', $rg);
			break;
		}

		$watch = 1 - $watch;

		break;
	}

	$rg['rg_form_token_tag'] = 'bug_watch';
	$rg['rg_form_token'] = rg_token_get($db, $rg, 'bug_watch');
	$rg['bug']['watch'] = 1 - $watch;
	$rg['HTML:watch_form'] = rg_template('repo/bug/b_watch.html',
		$rg, TRUE /*xss*/);
}
if (!empty($delete_error))
	$rg['HTML:watch_error'] = $delete_error;


// delete/undelete
$delete_error = '';
$del = $rg['bug']['deleted'] > 0;
while (rg_var_uint('del_doit') == 1) {
	// 1 = del, 2 = undel
	$del_undel = rg_var_uint("del_undel");

	if (($del_undel == 1) && $del)
		break;

	if (($del_undel == 2) && !$del)
		break;

	if (!rg_valid_referer()) {
		$delete_error = rg_warning("Invalid referer; try again", $rg);
		break;
	}

	if (!rg_token_valid($db, $rg, 'del_undel', FALSE)) {
		$delete_error = rg_warning("Invalid token; try again.", $rg);
		break;
	}

	$x['needed_rights'] = 'd';
	if (rg_rights_allow($db, $x) !== TRUE) {
		$delete_error = rg_template("repo/bug/deny_delete.html",
			$rg, TRUE /*xss*/);
		break;
	}

	$r = rg_bug_delete_undelete($db, $rg['login_ui']['uid'],
		$rg['ri']['repo_id'], $ibug['bug_id'], $del_undel);
	if ($r === FALSE) {
		$delete_error = rg_warning(rg_bug_error(), $rg);
		break;
	}

	$del = 1 - $del;
	break;
}
$rg['rg_form_token_tag'] = 'del_undel:' . $rg['rg_form_token'];
$rg['rg_form_token'] = rg_token_get($db, $rg, 'del_undel');
$rg['bug']['del'] = 1 - $del;
$rg['HTML:del_form'] = rg_template('repo/bug/b_del.html', $rg, TRUE /*xss*/);
if (!empty($delete_error))
	$rg['HTML:button_error'] = $delete_error;


// We must look it up again because it can be edited above; no prob, is in cache
$ibug = rg_bug_info($db, $rg['ri']['repo_id'], $rg['bug']['bug_id']);
if ($ibug === FALSE)
	rg_fatal("Cannot lookup bug!");
$rg = rg_array_merge($rg, "bug", $ibug);

$_bug_show .= rg_template("repo/bug/show.html", $rg, TRUE /*xss*/);
?>
