<?php
error_reporting(E_ALL | E_STRICT);
ini_set("track_errors", "On");

$INC = dirname(__FILE__) . "/../inc";
require_once(dirname(__FILE__) . "/config.php");
require_once($INC . "/init.inc.php");
require_once($INC . "/util.inc.php");
require_once($INC . "/log.inc.php");
require_once($INC . "/cache.inc.php");

rg_log_set_file("cache.log");

$rg_no_db = TRUE;
require_once("common.php");

rg_cache_core_set("a::b::c", "1");

$e = "1";
$r = rg_cache_core_get("a::b::c");
if ($r !== $e) {
	print_r($rg_cache);
	rg_log("[$r] != [$e]!");
	exit(1);
}

$e = FALSE;
$r = rg_cache_core_get("x::y::z");
if ($r !== $e) {
	print_r($rg_cache);
	rg_log("r must be FALSE!");
	exit(1);
}

rg_cache_core_unset("x::y::z");
$e = FALSE;
$r = rg_cache_core_get("x::y::z");
if ($r !== $e) {
	print_r($rg_cache);
	rg_log("r must be FALSE ($r)!");
	exit(1);
}

////////////////////////////////// Arrays

rg_cache_core_apush("v", "1");
rg_cache_core_apush("v", "2");
rg_cache_core_apush("v", "aa");
$e = "1,2,aa";
$r = rg_cache_core_adump("v");
if ($r !== $e) {
	print_r($rg_cache);
	rg_log("[$r] != [$e]!");
	exit(1);
}

$e = "aa";
$r = rg_cache_core_apop("v");
if ($r !== $e) {
	print_r($rg_cache);
	rg_log("[$r] != [$e]!");
	exit(1);
}

$e = "1";
$r = rg_cache_core_ashift("v");
if ($r !== $e) {
	print_r($rg_cache);
	rg_log("[$r] != [$e]!");
	exit(1);
}

$e = FALSE;
$r = rg_cache_core_ashift("v");
$r = rg_cache_core_ashift("v");
if ($r !== $e) {
	print_r($rg_cache);
	rg_log("r is not FALSE ($r)!");
	exit(1);
}

rg_log("OK!");

?>
